'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _chai = require('chai');

var _computeIndex = require('./computeIndex');

var _computeIndex2 = _interopRequireDefault(_computeIndex);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('computeIndex', function () {
  var children = void 0;

  beforeEach(function () {
    children = [_react2.default.createElement('div', { key: '1' }), _react2.default.createElement('div', { key: '2' }), _react2.default.createElement('div', { key: '3' })];
  });

  it('should compute the next index correctly', function () {
    var actual = (0, _computeIndex2.default)({
      children: children,
      indexLatest: 0,
      startX: 50,
      pageX: 10,
      viewLength: 100,
      resistance: false
    }).index;

    _chai.assert.strictEqual(actual, 0.4);
  });

  describe('resistance', function () {
    it('should not allow to go beyound the bounds when false', function () {
      var actual = (0, _computeIndex2.default)({
        children: children,
        indexLatest: 0,
        startX: 10,
        pageX: 50,
        viewLength: 100,
        resistance: false
      }).index;

      _chai.assert.strictEqual(actual, 0);
    });

    it('should allow to go beyound the bounds when true', function () {
      var actual = (0, _computeIndex2.default)({
        children: children,
        indexLatest: 0,
        startX: 10,
        pageX: 50,
        viewLength: 100,
        resistance: true
      }).index;

      _chai.assert.closeTo(actual, -0.21, 0.05);
    });
  });
}); //  weak